
#include <iostream>
#include <math.h>

using namespace std;

#ifndef MATRIX_H
#define MATRIX_H

class Matrix;

class Vector{

	private:
		float vect[3];

	public:
		Vector();
		Vector( float v1 , float v2 , float v3 );
		Vector( const Vector& );
		~Vector();

	
		void init( float v1 , float v2 , float v3 );
		void setVal( int pos , float val );
		const float getVal( int pos );
		
		void affiche();

		friend Vector operator* ( const Matrix& M , const Vector& V );
};


class Matrix{
	private:
		float mat[3][3];

	public:
		Matrix();
		Matrix( float m11 , float m12 , float m13 ,
				float m21 , float m22 , float m23 ,
				float m31 , float m32 , float m33 );
		Matrix( const Matrix& M );
		~Matrix();

		void init( float val );
		void identity();
		void translation( float x , float y );
		void zoom( float x , float y );
		void rotation( float cX , float cY , float angle );

		void setVal( int l , int c , float val );
		const float getVal( int l , int c );

		void affiche();

		Matrix& operator= ( const Matrix& M );

		friend Matrix operator+ ( const Matrix& M1 , const Matrix& M2 );
		friend Matrix operator- ( const Matrix& M1 , const Matrix& M2 );
		friend Matrix operator* ( const Matrix& M1 , const Matrix& M2 );
		friend Matrix operator* ( const Matrix& M , float val );
		friend Matrix operator* ( float val , const Matrix& M );
		friend Matrix operator/ ( const Matrix& M , float val );
		friend Matrix operator! (const Matrix& M );

		friend Vector operator* ( const Matrix& M , const Vector& V );
};

#endif
